VendorSearch = LibStub("AceAddon-3.0"):NewAddon("VendorSearch", "AceConsole-3.0", "AceEvent-3.0")

local options = {
    name = "VendorSearch",
    handler = VendorSearch,
    type = "group",
    args = {
     	search = {
	     	type = "input",
	     	name = "Keyword",
    	 	desc = "Enter your keyword",
    	 	usage = "<Name of the Item>",
			set = "SetKeyword",
			get = "GetKeyword",
     	},
 	    about = {
		     type = "group",
		     name = "About",
		     args = {
		     		about = {
		     			type = "description",
		     			name = "Copyright Adriweb 2009",
		 			},
		 	},
		},
		Options = {
	     	type = "group",
	     	name = "Options",
    	 	desc = "Configure VendorSearch",
			args = {
     			Verbose = {
	     			type = "toggle",
	     			name = "Verbose mode",
    	 			desc = "Toggle the Verbose mode",
					set = "ToggleVerbose",
					get = "IsVerbose",
     			},
     		},
     	},
	},
}


function VendorSearch:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("VendorSearch", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VendorSearch", "VendorSearch")
    self:RegisterChatCommand("vendorsearch", "ChatCommand")
 	self:RegisterChatCommand("vs", "ChatCommand")
end

function VendorSearch:OnEnable()
    -- Called when the addon is enabled
    DEFAULT_CHAT_FRAME:AddMessage("VendorSearch : Loaded")
    self:RegisterEvent("MERCHANT_SHOW")
end


function VendorSearch:OnDisable()
    -- Called when the addon is disabled
end

totalitems = GetMerchantNumItems();


--------------
--SearchBox:--
--------------
 
local searchbox = CreateFrame("EditBox","MerchantFrameSearchFrame",MerchantFrame,"InputBoxTemplate")
searchbox:SetFrameStrata("HIGH")
searchbox:SetAutoFocus(nil)
searchbox:SetWidth(160)
searchbox:SetHeight(26)
searchbox:SetPoint("TOP",10,-40)
searchbox:SetScript("OnEnterPressed", function(self)
	Keyword = searchbox:GetText()
	searchbox:ClearFocus()
	VendorSearch:Search(Keyword)
	end)
searchbox:SetScript("OnTextChanged", function(self)
	Keyword = searchbox:GetText()
	VendorSearch:Search(Keyword)
	end)


--------------
--Functions:--
--------------

function VendorSearch:GetKeyword(info)
    return Keyword
end

function VendorSearch:SetKeyword(info, newValue)
   Keyword = newValue
end

function VendorSearch:IsVerbose(info)
    return self.Verbose
end

function VendorSearch:ToggleVerbose(info, value)
    self.Verbose = value
end


function VendorSearch:MERCHANT_SHOW()
 VendorSearch:MERCHANT_LIST()
	for i=1,totalitems do
		name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
		link = GetMerchantItemLink(i);
		itemname = name
		if self.Verbose == true then
 			DEFAULT_CHAT_FRAME:AddMessage("Item " .. i .. " : " .. link .. " - " .. price .. " coppers");
		end
 	end
	if self.Keyword then
		VendorSearch:Search(self.Keyword)
	end
end

function VendorSearch:Search(Keyword)
 found = 0
 links = ""
	for i=1,totalitems do
 		name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
		link = GetMerchantItemLink(i);
 		itemname = name
 		if string.find(string.lower(itemname), string.lower(Keyword)) then
 			found = found + 1
 			if links == "" then
 				links = links .. link
 			else
 				links = links .. " , " .. link
 			end
		end
		if i == totalitems then
		DEFAULT_CHAT_FRAME:AddMessage(" ")
		DEFAULT_CHAT_FRAME:AddMessage("Results of search : Item(s) found from keyword \"" .. Keyword .. "\" : " .. found)
		DEFAULT_CHAT_FRAME:AddMessage(links)
		DEFAULT_CHAT_FRAME:AddMessage(" ")
		end
	end
end

function VendorSearch:MERCHANT_LIST()
	totalitems = GetMerchantNumItems();
	if self.Verbose == true then
		DEFAULT_CHAT_FRAME:AddMessage("Number of items : " .. totalitems);
	end
end


--------------
--Ace Stuff:--
--------------


function VendorSearch:ChatCommand(input)
   if (not input or input:trim() == "") then
        --InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
        LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(VendorSearch, "vs", "VendorSearch", input)
    end
end

function VendorSearch:ShowOptions()
    LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
end